From 9cf17c9f644a32705284e3a9827f88ebd832ee24 Mon Sep 17 00:00:00 2001
From: Jie Tang <tangjie18@huawei.com>
Date: Tue, 19 May 2020 10:52:14 +0800
Subject: [PATCH 11/16] cpu_hotplug: if default irq(15) not exist, need verify
 another.

Some machines do not contain irq(15) in file '/proc/irq', need verify
another one if irq(15) not exits.

Signed-off-by: Jie Tang <tangjie18@huawei.com>
---
 qemu/tests/cpu_hotplug.py | 13 ++++++++++++-
 1 file changed, 12 insertions(+), 1 deletion(-)

diff --git a/qemu/tests/cpu_hotplug.py b/qemu/tests/cpu_hotplug.py
index 13933913..ea583984 100644
--- a/qemu/tests/cpu_hotplug.py
+++ b/qemu/tests/cpu_hotplug.py
@@ -158,8 +158,19 @@ def run(test, params, env):
     # several times
     irq = 15
     irq_mask = "f0"
+    # if default irq num(15) is not exist, need verfiy another.
+    cmd = 'ls -l /proc/irq/15/smp_affinity'
+    status = session.cmd_status(cmd)
+    if status == 0:
+        irq = 15
+    else:
+        cmd = "cat /proc/interrupts | grep virtio[0-9]-input.0 | head -1 | awk -F ':' '{print$1}'"
+        irq = session.cmd_output(cmd).replace('\n','').replace(' ','')
+        if not irq:
+            logging.warn("Can not find irq number for virtio device, please check")
     for i in range(onoff_iterations):
-        session.cmd("echo %s > /proc/irq/%s/smp_affinity" % (irq_mask, irq))
+        if irq:
+            session.cmd("echo %s > /proc/irq/%s/smp_affinity" % (irq_mask, irq))
         for online_file in online_files:
             session.cmd("echo 0 > %s" % online_file)
         for online_file in online_files:
-- 
2.23.0

